#!/bin/bash


source ../_local_collect_config.bash

doc_id="HASH01b058d81d87cbb75516422b"

store_cwd="$PWD"
cd $GSDL3HOME/WEB-INF/cgi

export REQUEST_METHOD=GET
export QUERY_STRING="a=get-archives-assocfile&site=test-suite&c=$col&d=$doc_id&assocname=09_1_1_1.gif"



echo "========"
echo "Retrieving gsdlassocfile 'metadata' entries for $doc_id:"
echo "  URL: http://localhost:8383/greenstone3/cgi-bin/metadata-server.pl?$QUERY_STRING"
echo "--------"
#./metadata-server.pl
./metadata-server.pl 2>/dev/null | head --bytes 1024
echo "..."
echo ""
echo "--------"
echo ""



cd "$store_cwd"

echo "========"
echo "Uploading replacement gsdlassocfile file 09_1_1_1.gif for $doc_id:"
echo "--------"
echo curl -X POST -F "a=set-archives-assocfile" \
     -F "site=$site" -F "c=$col" -F "d=$doc_id" \
     -F "assocname=09_1_1_1.gif" \
     -F "fileupload=@testing-files/10_1_1_1_CHANGED.gif" \
     $gs_context_url/cgi-bin/metadata-server.pl
echo ""
curl -s -X POST -F "a=set-archives-assocfile" \
     -F "site=$site" -F "c=$col" -F "d=$doc_id" \
     -F "assocname=09_1_1_1.gif" \
     -F "fileupload=@testing-files/10_1_1_1_CHANGED.gif" \
     $gs_context_url/cgi-bin/metadata-server.pl > curl-output.txt

fgrep ERROR curl-output.txt >/dev/null 2>&1
curl_fgrep_error=$?

cat curl-output.txt
/bin/rm curl-output.txt

echo ""
echo "--------"
echo ""

if [ $curl_fgrep_error = 0 ] ; then

    echo "" >&2
    echo "Error: failed to run 'curl' command" >&2
    
    echo ""
    echo "The above 'curl' command posts a form to 'metadata-server.pl' as a URL, "
    echo "rather than setting QUERY_STRING and faking a run at the commandline."
    echo "This means it the Tomcat server operated version of metadta-server.pl that"
    echo "runs, and so the usual trick of setting GS3_AUTHENTICATED inside this script"
    echo "doesn't work, and the curl command will fail saying there is no action"
    echo "called 'set-archives-assocfile'"
    echo ""
    echo "A workaround is possible, by adjusting how tomcat is being run:"
    echo "    ant stop"
    echo "    export GS3_AUTHENTICATED=true"
    echo "    ant reset-logs"
    echo "    ant start"
    echo ""
    echo "This effectively pulls off the same within-script trick, only getting"
    echo "it into the environment so Tomcat sees it, and passess it on when it"
    echo "runs metadata-server.pl"
else
   
    echo "+ Checking the following files are different:"
    echo "+   import/09/images/09_1_1_1.gif archives/HASH01b0.dir/09_1_1_1.gif"
    
    ls -li import/09/images/09_1_1_1.gif archives/HASH01b0.dir/09_1_1_1.gif
    
    diff import/09/images/09_1_1_1.gif archives/HASH01b0.dir/09_1_1_1.gif
    
    diff_status=$?
    
    if [ $diff_status != 0 ] ; then
	echo "+"
	echo "+  Diff-test Successful!"
	echo "+"
    fi
fi

echo ""

echo "========"
echo "Uploading (URLencoded POST) replacement gsdlassocfile file mydata.json using 'filedata=' for $doc_id:"
echo "--------"
#echo curl -X POST -F "a=set-archives-assocfile" \
#     -F "site=$site" -F "c=$col" -F "d=$doc_id" \
#     -F "mydata.json" \
#     -F 'filedata="{\"test_val\": 1, \"test_bool\": true, \"test_str\": \"a val\", \"test_array\": [ 1, 2, 3 ] }"' \
#     $gs_context_url/cgi-bin/metadata-server.pl

echo curl -d "a=set-archives-assocfile&site=$site&c=$col&d=$doc_id&assocname=myfile.json" \
     -d 'filedata={"test_val": 1, "test_bool": true, "test_str": "a val", "test_array": [ 1, 2, 3 ] }' \
     $gs_context_url/cgi-bin/metadata-server.pl

echo ""
curl -s -d "a=set-archives-assocfile&site=$site&c=$col&d=$doc_id&assocname=myfile.json" \
     -d 'filedata={"test_val": 1, "test_bool": true, "test_str": "a val", "test_array": [ 1, 2, 3 ] }' \
     $gs_context_url/cgi-bin/metadata-server.pl
